import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import swarm.collections.*;

public class Fish extends SwarmObjectImpl{
	double xPos, yPos;//fisḧʒu
	double newX,newY;//fisḧړ̈ʒu
	int worldXSize, worldYSize;
	Grid2d world;
	int die=0;//񂾉
	int loop=0;//ړ
	
	/* ʂ̃p[^̐ݒ */
	double v=1;//x
	double direction=Math.random()*Math.PI*2;//fisȟĂpx,0~2pi
	int near=3;//Փ˂邽ߗ͈
	int middle=15;//ƕ킹͈
	int far=30;//QT͈
	double straightWeight=1;//OƓɐiƂd
	double nearWeight=10;//d
	double middleWeight=1;//킹d
	double farWeight=0.3;//QɊd
	double randomdir=Math.PI/180;//ړɏ_
	double accel=0.01;//Qꂩ痣ĂƂC
	double avoidrange=8;//predator𔭌ł͈
	double avoidWeight=10000;//predator瓦d݁Cقږ
	double curve=Math.PI/3;//fish̋Ȃpx̏
	
	public Fish(Zone aZone){
		super(aZone);
	}
	
	public Object setWorld(Grid2d w){
		world=w;
		setWorldSizeX$Y(world.getSizeX(),world.getSizeY());
		return this;
	}
	
	public Object setX$Y(double x, double y){
		xPos = x;
		yPos = y;
		world.putObject$atX$Y(this,(int)xPos,(int)yPos);
		return this;
	}
	
	public Object setWorldSizeX$Y(int xSize, int ySize){
		worldXSize=xSize;
		worldYSize=ySize;
		return this;
	}
	
	//fisȟ݈ʒu𒆐Seatenrangepredator玀ʁC_Ȉʒuŕ
	public void liveordie(List predatorList){
		for(int i=0;i<predatorList.getCount();i++){
			Predator aPredator=(Predator)predatorList.atOffset(i);
				double dist=Math.pow(donutDistance(aPredator.xPos,xPos,worldXSize),2)+Math.pow(donutDistance(aPredator.yPos,yPos,worldYSize),2);
				if(dist<Math.pow(aPredator.eatrange,2)){
					die++;
					xPos=Math.random()*worldXSize;
					yPos=Math.random()*worldYSize;
				}
		}
	}
	
	//(x0,y0)݂(x1,y1)̊pxԂC͈͂0~2pi
	public double vectorAngle(double x0, double y0, double x1, double y1){
		double rad = Math.atan2(y1-y0,x1-x0);
		if(rad<0){//0~2pi͈̔͂ɕϊ
			rad=2*Math.PI+rad;
		}
		return rad;
	}
	
	/* h[ibc^EiEƍCƉqĂ鐢Ejɂx0x1ւ̋ԂDD
	   pxɂgDႦx0=30x,x1=60xȂ30xԂCx0=10x,x1=350xȂ-20xԂ */
	public double donutDistance(double x0, double x1, double worldsize){
		double dist;
		if(x0<x1){
			dist=x1-x0;
			if(x0+worldsize-x1<dist){
				dist=x1-x0-worldsize;
			}
		}
		else{
			dist=x1-x0;
			if(x0-x1-worldsize>dist){
				dist=x1-x0+worldsize;
			}
		}
		return dist;
	}

	//fishړ֐
	public void step(List fishList, List predatorList){
		loop++;
		double newdirection;//fishړpx
		double newXdir=straightWeight*Math.cos(direction);//fishxɈړ
		double newYdir=straightWeight*Math.sin(direction);//fishyɈړ
		int farfish=0;//far͈͂ɂ钇Ԃ̐
		double gx=0, gy=0;//Q̒S̈ʒu
		
		//SĂ̒ԂĈړ߂
		for(int i=0;i<fishList.getCount();i++){
			Fish aFish=(Fish)fishList.atOffset(i);
			double sx=aFish.xPos;
			double sy=aFish.yPos;
			double dist=Math.pow(donutDistance(sx,xPos,worldXSize),2)+Math.pow(donutDistance(sy,yPos,worldYSize),2);
			//̓XLbv
			if(sx==xPos && sy==yPos){}
			//anearȓT
			else if(dist<=Math.pow(near,2)){
				double rad=vectorAngle(0,0,donutDistance(xPos,sx,worldXSize),donutDistance(yPos,sy,worldYSize));
				//߂ԂƐ(+pi)̕֐i,1C̉e͍XnearWeight
				newXdir+=nearWeight*Math.cos((rad+Math.PI)%(Math.PI*2));
				newYdir+=nearWeight*Math.sin((rad+Math.PI)%(Math.PI*2));
			}
			
			//middleɒԂ邩T
			else if(dist<=Math.pow(middle,2)){
				double rad = aFish.direction;
				//̒ԂƓɐi,1C̉e͍XnearWeight
				newXdir+=middleWeight*Math.cos(rad);
				newYdir+=middleWeight*Math.sin(rad);
			}
			
			//farɂ钇ԂT
			else if(dist<=Math.pow(far,2)){
				farfish++;
				//farɂ钇Ԃ̏dS
				gx+=donutDistance(xPos,sx,worldXSize);
				gy+=donutDistance(yPos,sy,worldYSize);
			}
		}
		//Q̒S֌
		if(farfish>0){
			gx=gx/farfish;
			gy=gy/farfish;
			newXdir+=farWeight*gx;
			newYdir+=farWeight*gy;
		}
		
		//ɑSĂpredatorē
		for(int i=0;i<predatorList.getCount();i++){
			Predator aPredator=(Predator)predatorList.atOffset(i);
			double sx=aPredator.xPos;
			double sy=aPredator.yPos;
			//predatorƎƂ̋
			double dist=Math.pow(donutDistance(sx,xPos,worldXSize),2)+Math.pow(donutDistance(sy,yPos,worldYSize),2);
			if(dist<=Math.pow(avoidrange,2)){
				double rad=0;
				//predator݂̊px
				double radbetween=vectorAngle(0,0,donutDistance(aPredator.xPos,xPos,worldXSize),donutDistance(aPredator.yPos,yPos,worldYSize));
				//predator̐isƐɓC2̐̂ɓ
				if(donutDistance(aPredator.direction,radbetween,2*Math.PI)>0){
					rad=(aPredator.direction+Math.PI/2)%(Math.PI*2);
				}
				else{
					rad=(aPredator.direction-Math.PI/2)%(Math.PI*2);
				}
				newXdir+=avoidWeight*Math.cos(rad);
				newYdir+=avoidWeight*Math.sin(rad);
			}
		}
		
		
		/* ܂łňړ͌܂ */
		//randomdir_ɂ炷,2fisḧʒuSɔꍇꐶ˂Ȃ̂
		newdirection=vectorAngle(0,0,newXdir,newYdir)+(2*Math.random()-1)*randomdir;
		
		//}ȕ]͖,Ȃpx̏curve
		if(donutDistance(direction,newdirection,2*Math.PI)>curve){
			newdirection=direction+curve;
		}
		else if(donutDistance(direction,newdirection,2*Math.PI)<-curve){
			newdirection=direction-curve;
		}
		
		//QɌĂꍇɂiǗĂƂƌQ̌̕ɂƂj
		int vflag=0;//QɌĂ邩ǂ̃tO
		//Q̒SƎ̐isvĂȂtO𗧂Ă
		if(donutDistance(direction,vectorAngle(0,0,gx,gy),2*Math.PI)<Math.PI/2 && 
		donutDistance(direction,vectorAngle(0,0,gx,gy),2*Math.PI)>-Math.PI/2){
			vflag=1;
		}
		
		//x,ÿړʂvZ
		newXdir=Math.cos(newdirection);
		newYdir=Math.sin(newdirection);
		
		//newdirectionƂ1ړ
		newX = xPos + (v+vflag*Math.random()*accel)*newXdir;
		newY = yPos + (v+vflag*Math.random()*accel)*newYdir;
		newX = (newX + worldXSize) % worldXSize;
		newY = (newY + worldYSize) % worldYSize;
		direction=newdirection;
	}
	
	//ɎȂȂobjectuCuĂȂʒu̍XV
	public Object putSelfOn(){
		if(world.getObjectAtX$Y((int)newX,(int)newY)==null){
			setX$Y(newX,newY);
		}
		else{
			xPos=newX;
			yPos=newY;
		}
		return this;
	}
	
	public Object drawSelfOn(Raster r){
		r.drawPointX$Y$Color((int)xPos,(int)yPos,(byte)2);
		return this;
	}
	
	public void printXY(){//̈ʒu𐔒lŏóifobOpj
		System.out.println((int)xPos+":"+(int)yPos);
	}
}