import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import swarm.collections.*;

public class Predator extends SwarmObjectImpl{
	double xPos, yPos;//predator̈ʒu
	double newX,newY;//predator̈ړ̈ʒu
	int worldXSize, worldYSize;
	Grid2d world2;
	
	/* ߐHҌʂ̃p[^̐ݒ */
	double v=3;//x
	double direction=Math.random()*Math.PI*2;//predatořĂpx
	double randomdir=Math.PI/18;//ړɏ_
	double findrange=30;//fish𔭌ł͈
	double accel=0.3;//ߐHuԂɉł鑬
	double curve=Math.PI/12;//predator̋Ȃpx̏
	double eatrange=0.3;//predator̕ߐH͈,predatoȓ̂痣ĕߐHł͈́iJG̐̂悤ȃC[Wj
	
	public Predator(Zone aZone){
		super(aZone);
	}
	
	public Object setWorld(Grid2d w){
		world2=w;
		setWorldSizeX$Y(world2.getSizeX(),world2.getSizeY());
		return this;
	}
	
	public Object setX$Y(double x, double y){
		xPos = x;
		yPos = y;
		world2.putObject$atX$Y(this,(int)xPos,(int)yPos);
		return this;
	}
	
	public Object setWorldSizeX$Y(int xSize, int ySize){
		worldXSize=xSize;
		worldYSize=ySize;
		return this;
	}
	
	//Fish.java̒Ɠ
	public double vectorAngle(double x0, double y0, double x1, double y1){//2_ԃxN^̊pxԂ
		double rad = Math.atan2(y1-y0,x1-x0);
		if(rad<0){//0~2pi͈̔͂ɕϊ
			rad=2*Math.PI+rad;
		}
		return rad;
	}
	
	//Fish.java̒Ɠ
	public double donutDistance(double x0, double x1, double worldsize){//h[ibc^n}ł̂鎟̋Ԃ,x0->x1
		double dist;
		if(x0<x1){
			dist=x1-x0;
			if(x0+worldsize-x1<dist){
				dist=x1-x0-worldsize;
			}
		}
		else{
			dist=x1-x0;
			if(x0-x1-worldsize>dist){
				dist=x1-x0+worldsize;
			}
		}
		return dist;
	}
	
	public void step(List fishList){
		double newXdir=0;
		double newYdir=0;
		
		//ԋ߂fish_
		double mindist=Math.pow(worldXSize,2)+Math.pow(worldYSize,2);
		double minX=0,minY=0;//ԋ߂fisḧʒu
		double radbetween=0;//predator猩ԋ߂fish̊px
		
		//SĂfish݂Ĉԋ߂̂̈ʒuƊpxi[
		for(int i=0;i<fishList.getCount();i++){
			Fish aFish=(Fish)fishList.atOffset(i);
			double sx=aFish.xPos;
			double sy=aFish.yPos;
			double dist=Math.pow(donutDistance(sx,xPos,worldXSize),2)+Math.pow(donutDistance(sy,yPos,worldYSize),2);
			if(mindist>dist){
				mindist=dist;
				minX=sx;
				minY=sy;
				radbetween=vectorAngle(xPos,yPos,aFish.xPos,aFish.yPos);
			}
		}
		
		//ňړł鋗&&pxfish΂܂ňړ
		if(mindist<=Math.pow((v+accel),2) && Math.abs(donutDistance(direction,radbetween,Math.PI*2))<curve){
			newX=minX;
			newY=minY;
			direction=vectorAngle(0,0,donutDistance(xPos,minX,worldXSize),donutDistance(yPos,minY,worldYSize));
		}
		//ł͈ړłȂfindrangefish炻֌
		else if(mindist<=Math.pow(findrange,2)){
			double newdirection=vectorAngle(0,0,donutDistance(xPos,minX,worldXSize),donutDistance(yPos,minY,worldYSize));
			//}ȕ]͖,őcurveȂȂ
			if(donutDistance(direction,newdirection,2*Math.PI)>curve){
				direction=direction+curve;
			}
			else if(donutDistance(direction,newdirection,2*Math.PI)<-curve){
				direction=direction-curve;
			}
			else{
				direction=newdirection;
			}
			newXdir+=Math.cos(direction);
			newYdir+=Math.sin(direction);
			newX=xPos+v*newXdir;
			newY=yPos+v*newYdir;
		}
		//fishȂ΂pxςĒi
		else{
			direction=direction+(2*Math.random()-1)*randomdir;
			newX=xPos+v*Math.cos(direction);
			newY=yPos+v*Math.sin(direction);
			
		}
		newX = (newX + worldXSize) % worldXSize;
		newY = (newY + worldYSize) % worldYSize;
	}
	
	//ɎȂȂobjectuCuĂȂʒu̍XV
	public Object putSelfOn(){
		if(world2.getObjectAtX$Y((int)newX,(int)newY)==null){
			setX$Y(newX,newY);
		}
		else{
			xPos=newX;
			yPos=newY;
		}
		return this;
	}

	public Object drawSelfOn(Raster r){
		r.drawPointX$Y$Color((int)xPos,(int)yPos,(byte)1);
		return this;
	}
}